#petit plug d'"explosion dplacement" de groupes ou de composants

require 'sketchup.rb'
def pilou_explose
model = Sketchup.active_model
entities = model.entities
selection = model.selection
ss = selection

if selection.empty?
UI.messagebox "Veuillez Slectionner des\nComposants ou des Groupes"
end
model.start_operation "Deplacement Eclate"
group = model.active_entities.add_group(ss)
center1 = group.bounds.center
entities.add_cpoint(center1)
result = UI.messagebox "Voulez vous faire une copie de l'original", MB_YESNO
    if result == 6
        group2 = group.copy
        group2.explode
    end
selection = group.explode
xp = center1[0].to_i   # dtermination du centre de
yp = center1[1].to_i   # la slection
zp = center1[2].to_i   #
prompts = ["Dplacement pivot x", "Dplacement pivot y", "Dplacement pivot z", "Amplitude translation x", "Amplitude translation y", "Amplitude translation z","Dcalage du plan x", "Dcalage du plan y", "Dcalage du plan z", "Groupe Composant les 2"]
values = [xp, yp, zp, 10, 10, 10, 0, 0, 0, "Les 2"]
list = ["", "", "", "", "", "" , "", "", "", "Groupe|Composant|Les 2"]
results = UI.inputbox prompts, values, list, "Parametres"
return if not results
xpn, ypn, zpn, qx, qy, qz, xpnd, ypnd, zpnd, gc = results

qx = qx.to_i  # Translation sur l'axe x
qy = qy.to_i  # Translation sur l'axe y
qz = qz.to_i  # Translation sur l'axe z

entities.add_cpoint [xpn,ypn,zpn]
entities.add_cline [xp, yp, zp],[xpn, ypn, zpn]

xp = xp+xpnd   # decalage du plan 0 de l'clat
yp = yp+ypnd   #
zp = zp+zpnd   #

xpd =  xpn-xp # Calcul de la distance entre
ypd =  ypn-yp # le centre d'origine de la slection
zpd =  zpn-zp # et le nouveau (=0 si aucun changement)

	if gc == "Groupe"
	gc = Sketchup::Group
	cc = Sketchup::Group
	elsif gc == "Composant"
	gc = Sketchup::ComponentInstance
	cc = Sketchup::ComponentInstance
	elsif gc == "Les 2"
	gc = Sketchup::Group
	cc = Sketchup::ComponentInstance	
	end

	selection.each do |e| # dbut de la boucle de dplacement des objets

	next unless (e.is_a? gc) or next unless(e.is_a? cc)
	center = e.bounds.center
	xc = center[0].to_i  # Determination 
	yc = center[1].to_i  # du centre
	zc = center[2].to_i  # de l'objet
	
	# entities.add_cpoint [xc, yc, zc]
    	
	# xpc = xc-xp   # Calcul de la distance
	# ypc = yc-yp   # entre le centre d'origine
	# zpc = zc-zp   # et le centre de l'objet

	xe = xpd   # coordonnes du nouveau centre de l'objet 
	ye = ypd   # quand l'objet est sur le mme plan (xp=xc...)
	ze = zpd   # pas de dplacement  (on peut mettre xpd...)
		
	if xc<xp
    xe = -qx+xpd
    end

    if xc>xp
    xe = qx+xpd
    end

    if yc<yp
    ye = -qy+ypd
    end

    if yc>yp
    ye = qy+ypd
    end

    if zc<zp
    ze = -qz+zpd
    end

    if zc>zp
    ze = qz+zpd
    end
    	
	point = Geom::Point3d.new xe,ye,ze
	t = Geom::Transformation.new point
	e.transform!(t)

	end
model.commit_operation
end

	if( not file_loaded?("Eclate_Deplace.rb") )
	UI.add_context_menu_handler do |context_menu|
	context_menu.add_separator
	context_menu.add_item("Eclate_Deplace") { pilou_explose }
	end
	file_loaded("Eclate_Deplace.rb")
	end
